Subject: Re: [Idr] draft-ietf-idr-segment-routing-te-policy Policy Name Sub-TLV considerations

From: "Ketan Talaulikar (ketant)" <[email-masked]>
Date: Thu, 12 Mar 2020 12:21:34 +0000

Hello,

Would like to bring back this topic for discussion and inputs from the IDR & SPRING WGs. 

We need to ask if the "SR Policy Name" object is something that needs localization (i.e. we change the encoding from ASCII to UTF-8).

According to rfc6365 "Localization is the act of tailoring an application for a different language or script or culture."  The question then arises: would someone want to define a policy name in something other than a language supported by ASCII?  English is supported, but there are other languages which are not.

This object traces it roots to the draft-ietf-spring-segment-routing-policy document which indicates the use of "printable ASCII characters" : https://tools.ietf.org/html/draft-ietf-spring-segment-routing-policy-06#section-2.1
So any changes to the encoding would need to be reflected in this document (and other protocols and Yang models as an extension).

Further on, the equivalent object in PCEP has been already defined as using ASCII in the now published https://tools.ietf.org/html/rfc8231#section-7.3.2 

Based on the WG inputs, we can determine the next course of action.

Thanks,
Ketan

-----Original Message-----
From: Ketan Talaulikar (ketant) 
Sent: 13 February 2020 23:38
To: Jeffrey Haas <[email-masked]>; [email-masked]; [email-masked]
Subject: RE: draft-ietf-idr-segment-routing-te-policy Policy Name Sub-TLV considerations

Hi Jeff,

I agree with you about the limits on the policy name size. 

I am not aware of any IETF standard that mandates the use of UTF-8 for encoding of string for names. The similar object in PCEP is encoded in ASCII - https://tools.ietf.org/html/rfc8231#section-7.3.2 

Thanks,
Ketan

-----Original Message-----
From: Jeffrey Haas <[email-masked]> 
Sent: 12 February 2020 15:17
To: [email-masked]; [email-masked]
Subject: draft-ietf-idr-segment-routing-te-policy Policy Name Sub-TLV considerations

Authors,

In draft-ietf-idr-segment-routing-te-policy-08, Section 2.4.6 we have a TLV for Policy Name.  Its text is:

: 2.4.6.  Policy Name Sub-TLV
: 
:    An operator MAY set the Policy Name sub-TLV to attach a symbolic name
:    to the SR Policy candidate path.
: 
:    Usage of Policy Name sub-TLV is described in section 2 in
:    [I-D.ietf-spring-segment-routing-policy].
: 
:    The Policy Name sub-TLV may exceed 255 bytes length due to long
:    policy name.  Therefore a 2-octet length is required.  According to
:    [I-D.ietf-idr-tunnel-encaps], the first bit of the sub-TLV codepoint
:    defines the size of the length field.  Therefore, for the Policy Name
:    sub-TLV a code point of 128 or higher is used.
: 
:    The Policy Name sub-TLV is optional and it MUST NOT appear more than
:    once in the SR Policy TLV.
: 
:    The Policy Name sub-TLV has following format:
: 
:    0                   1                   2                   3
:     0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1
:    +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
:    |     Type      |   Length                      |   RESERVED    |
:    +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
:    //                        Policy Name                          //
:    +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
: 
:    Where:
: 
:       Type: 129.
: 
:       Length: Variable.
: 
:       RESERVED: 1 octet of reserved bits.  SHOULD be set to zero on
:       transmission and MUST be ignored on receipt.
: 
:       Policy Name: Symbolic name for the policy.  It SHOULD be a string
:       of printable ASCII characters, without a NULL terminator.

draft-ietf-spring-segment-routing-policy-06, Section 2.1 discusses this
Sub-TLV:

:    An implementation MAY allow assignment of a symbolic name comprising
:    of printable ASCII characters to an SR Policy to serve as a user-
:    friendly attribute for debug and troubleshooting purposes.  Such
:    symbolic names may identify an SR Policy when the naming scheme
:    ensures uniqueness.

There are two observations I'd like to make:
1. A 65K length isn't very likely in BGP. :-)  I suggest that greater guidance for shorter names should be offered. For example, perhaps limit the length to 1K.  Alternatively, offer advice such as: "Implementations may choose to truncate long Policy Names".

2. The guidance about "printable ASCII" is rather old-style and likely to run askance of IESG review for internationalization considerations.  I'd suggest that the field be encoded in UTF-8 and make reference to print-safety similar to RFC 8203 (BGP Administrative Shutdown) in its Security Considerations.

-- Jeff

---

From: Andrew Alston <[email-masked]>
Date: Thu, 12 Mar 2020 12:27:20 +0000

I would be quite happy to stick to ascii here - it makes writing implementations simpler - and while I've seen one hardware vendor that had an entire cli in Cyrillic -  I'm not entirely sure that it justifies such a change.

Then again - I'm a native English speaker so I'm biased - and the preference here isn't really strong on my side.

Andrew

From: spring <[email-masked]> On Behalf Of Ketan Talaulikar (ketant)
Sent: Thursday, 12 March 2020 15:22
To: [email-masked]; [email-masked]
Cc: Jeffrey Haas <[email-masked]>; [email-masked]; Alvaro Retana <[email-masked]>
Subject: Re: [spring] draft-ietf-idr-segment-routing-te-policy Policy Name Sub-TLV considerations

Hello,

This object traces it roots to the draft-ietf-spring-segment-routing-policy document which indicates the use of "printable ASCII characters" : https://tools.ietf.org/html/draft-ietf-spring-segment-routing-policy-06#section-2.1<https://tools.ietf.org/html/draft-ietf-spring-segment-routing-policy-06#section-2.1>
So any changes to the encoding would need to be reflected in this document (and other protocols and Yang models as an extension).

Further on, the equivalent object in PCEP has been already defined as using ASCII in the now published https://tools.ietf.org/html/rfc8231#section-7.3.2<https://tools.ietf.org/html/rfc8231#section-7.3.2>

Thanks,
Ketan

-----Original Message-----
From: Ketan Talaulikar (ketant)
Sent: 13 February 2020 23:38
To: Jeffrey Haas <[email-masked]<mailto:[email-masked]>>; [email-masked]<mailto:[email-masked]>; [email-masked]<mailto:[email-masked]>
Subject: RE: draft-ietf-idr-segment-routing-te-policy Policy Name Sub-TLV considerations

Hi Jeff,

I am not aware of any IETF standard that mandates the use of UTF-8 for encoding of string for names. The similar object in PCEP is encoded in ASCII - https://tools.ietf.org/html/rfc8231#section-7.3.2<https://tools.ietf.org/html/rfc8231#section-7.3.2>

Thanks,
Ketan

-----Original Message-----
From: Jeffrey Haas <[email-masked]<mailto:[email-masked]>>
Sent: 12 February 2020 15:17
To: [email-masked]<mailto:[email-masked]>; [email-masked]<mailto:[email-masked]>
Subject: draft-ietf-idr-segment-routing-te-policy Policy Name Sub-TLV considerations

Authors,

-- Jeff

_______________________________________________
spring mailing list
[email-masked]<mailto:[email-masked]>
https://www.ietf.org/mailman/listinfo/spring<https://www.ietf.org/mailman/listinfo/spring>

---

From: Nandan Saha <[email-masked]>
Date: Thu, 12 Mar 2020 21:07:19 +0530

On a slight tangent, can we please call the sub tlv "Candidate path name"
or some such. It's more accurate than "policy name" since the candidate
path is signalled in bgp, not a policy.

On Thu, Mar 12, 2020 at 5:57 PM Andrew Alston <
[email-masked]> wrote:

> I would be quite happy to stick to ascii here – it makes writing
> implementations simpler – and while I’ve seen one hardware vendor that had
> an entire cli in Cyrillic -  I’m not entirely sure that it justifies such a
> change.
>
>
>
> Then again – I’m a native English speaker so I’m biased – and the
> preference here isn’t really strong on my side.
>
>
>
> Andrew
>
>
>
>
>
> *From:* spring <[email-masked]> *On Behalf Of *Ketan Talaulikar
> (ketant)
> *Sent:* Thursday, 12 March 2020 15:22
> *To:* [email-masked]; [email-masked]
> *Cc:* Jeffrey Haas <[email-masked]>;
> [email-masked]; Alvaro Retana <
> [email-masked]>
> *Subject:* Re: [spring] draft-ietf-idr-segment-routing-te-policy Policy
> Name Sub-TLV considerations
>
>
>
> Hello,
>
> We need to ask if the "SR Policy Name" object is something that needs
> localization (i.e. we change the encoding from ASCII to UTF-8).
>
> According to rfc6365 "Localization is the act of tailoring an application
> for a different language or script or culture." The question then arises:
> would someone want to define a policy name in something other than a
> language supported by ASCII? English is supported, but there are other
> languages which are not.
>
> This object traces it roots to the
> draft-ietf-spring-segment-routing-policy document which indicates the use
> of "printable ASCII characters" :
> https://tools.ietf.org/html/draft-ietf-spring-segment-routing-policy-06#section-2.1
> So any changes to the encoding would need to be reflected in this document
> (and other protocols and Yang models as an extension).
>
> Further on, the equivalent object in PCEP has been already defined as
> using ASCII in the now published
> https://tools.ietf.org/html/rfc8231#section-7.3.2
>
> To: Jeffrey Haas <[email-masked]>;
> [email-masked]; [email-masked]
> I am not aware of any IETF standard that mandates the use of UTF-8 for
> encoding of string for names. The similar object in PCEP is encoded in
> ASCII - https://tools.ietf.org/html/rfc8231#section-7.3.2
>
> Thanks,
> Ketan
>
> 1. A 65K length isn't very likely in BGP. :-) I suggest that greater
> guidance for shorter names should be offered. For example, perhaps limit
> the length to 1K. Alternatively, offer advice such as: "Implementations may
> choose to truncate long Policy Names".
>
> 2. The guidance about "printable ASCII" is rather old-style and likely to
> run askance of IESG review for internationalization considerations.. I'd
> suggest that the field be encoded in UTF-8 and make reference to
> print-safety similar to RFC 8203 (BGP Administrative Shutdown) in its
> Security Considerations.
>
> -- Jeff
>
> [email-masked]
> https://www.ietf.org/mailman/listinfo/spring
> Idr mailing list
> [email-masked]
> https://www.ietf.org/mailman/listinfo/idr
>

---

From: <[email-masked]>
Date: Wed, 25 Mar 2020 16:32:01 +0000

Hi Ketan,
 
> From: Idr [mailto:[email-masked]] On Behalf Of Ketan Talaulikar (ketant)
> 
> Hi Jeff,
> 
> I am not aware of any IETF standard that mandates the use of UTF-8 for encoding of string for names. 

FYI, I've just noticed the following

"All user-visible text fields must be internationalizable. See [RFC 2277] (Alvestrand, H., "IETF Policy on Character Sets and Languages," January 1998.). 
For most cases, this means UTF-8 [RFC 3629] (Yergeau, F., "UTF-8, a transformation format of ISO 10646," November 2003.)."
https://www.ietf.org/standards/ids/checklist/

> The similar object in PCEP is encoded in ASCII - https://tools.ietf.org/html/rfc8231#section-7.3.2

Ah... 

Good luck!
 
--Bruno

> :    The Policy Name sub-TLV has following format:

_________________________________________________________________________________________________________________________

Ce message et ses pieces jointes peuvent contenir des informations confidentielles ou privilegiees et ne doivent donc
pas etre diffuses, exploites ou copies sans autorisation. Si vous avez recu ce message par erreur, veuillez le signaler
a l'expediteur et le detruire ainsi que les pieces jointes. Les messages electroniques etant susceptibles d'alteration,
Orange decline toute responsabilite si ce message a ete altere, deforme ou falsifie. Merci.

This message and its attachments may contain confidential or privileged information that may be protected by law;
they should not be distributed, used or copied without authorisation.
If you have received this email in error, please notify the sender and delete this message and its attachments.
As emails may be altered, Orange is not liable for messages that have been modified, changed or falsified.
Thank you.